# -*- coding: utf-8 -*-
# Generated by Django 1.11.11 on 2019-01-09 15:28


from django.conf import settings
import django.contrib.postgres.fields
import django.contrib.postgres.fields.jsonb
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Message',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_datetime', models.DateTimeField(blank=True, default=django.utils.timezone.now, null=True)),
                ('status', models.CharField(choices=[('draft', 'Draft'), ('preparing', 'Preparing for sending'), ('sending', 'Sending'), ('error', 'Error'), ('sent', 'Sent')], db_index=True, default='draft', max_length=30)),
                ('status_data', django.contrib.postgres.fields.jsonb.JSONField(blank=True, default=dict)),
                ('metadata', django.contrib.postgres.fields.jsonb.JSONField(blank=True, default=dict)),
                ('context_type', models.CharField(choices=[('other', 'Other'), ('comment_delivery', 'Comment or delivery'), ('deadline_moved', 'Deadline moved'), ('new_attempt', 'New attempt'), ('feedback', 'Feedback'), ('feedback_updated', 'Grading updated')], default='other', max_length=255)),
                ('message_type', django.contrib.postgres.fields.ArrayField(base_field=models.CharField(max_length=30), size=None)),
                ('virtual_message_receivers', django.contrib.postgres.fields.jsonb.JSONField(blank=True, default=dict)),
                ('created_by', models.ForeignKey(blank=True, default=None, null=True, on_delete=django.db.models.deletion.SET_NULL, to=settings.AUTH_USER_MODEL)),
            ],
        ),
        migrations.CreateModel(
            name='MessageReceiver',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_datetime', models.DateTimeField(blank=True, default=django.utils.timezone.now, null=True)),
                ('status', models.CharField(choices=[('not_sent', 'Not sent'), ('failed', 'Failed'), ('error', 'Error'), ('sent', 'Sent')], default='not_sent', max_length=10)),
                ('status_data', django.contrib.postgres.fields.jsonb.JSONField(blank=True, default=dict)),
                ('metadata', django.contrib.postgres.fields.jsonb.JSONField(blank=True, default=dict)),
                ('subject', models.CharField(blank=True, default='', max_length=255)),
                ('message_content_plain', models.TextField(blank=True, default='')),
                ('message_content_html', models.TextField(blank=True, default='')),
                ('message_type', models.CharField(db_index=True, max_length=30)),
                ('send_to', models.CharField(blank=True, default='', max_length=255)),
                ('sent_datetime', models.DateTimeField(blank=True, null=True)),
                ('sending_failed_count', models.IntegerField(default=0)),
                ('sending_success_count', models.IntegerField(default=0)),
                ('message', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='devilry_message.Message')),
                ('user', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL)),
            ],
        ),
    ]
